      SUBROUTINE QST2R(RINT,A,B,F,N,EPS,K,IND,R,IERR)
         REAL A,B,EPS,R,RINT
         DIMENSION IND(N),R(N,2),RINT(N)
         EXTERNAL UTQS10
         REAL E,H,RH,RI
    1  IERR = 0
       DO 10 I = 1, N
          R(I,2) = 0.
          IND(I) = 0
   10  CONTINUE
 1000  K1 = K
       IF (K .LE. 0) K1 = 1
       CALL F(A,RINT,IND)
       CALL F(B,R,IND)
       H = (B - A)/K1
       DO 20 I = 1, N
          RINT(I) = (RINT(I) + R(I,1))*H*.5
   20  CONTINUE
 1001  IF (K1 .EQ. 1) GO TO 50
          K2 = K1 - 1
          DO 40 J = 1, K2
             CALL F(A + J*H,R,IND)
             DO 30 I = 1, N
                RINT(I) = RINT(I) + R(I,1)*H
   30        CONTINUE
   40     CONTINUE
   50  CONTINUE
 1002  IF (EPS .LE. 0.) GO TO 100
   60  CONTINUE
 1003  H = H*.5
       DO 80 J = 1, K1
          CALL F(A + (2.*J - 1.)*H,R,IND)
          DO 70 I = 1, N
             R(I,2) = R(I,2) + R(I,1)
   70     CONTINUE
   80  CONTINUE
1004   K2 = 1
       DO 90 I = 1, N
          IF (IND(I) .GT. 0) GO TO 90
             RH = R(I,2)*H
             RI = RINT(I)*.5
             RINT(I) = RH + RI
             E = ABS(RH-RI)/(1. + ABS(RINT(I)))
             IF (E .LE. EPS) IND(I) = K1
             IF (IND(I) .EQ. 0) K2 = 0
             R(I,2) = 0.
   90  CONTINUE
       IF (K2 .GT. 0) GO TO 100
          K1 = K1 + K1
          IF (K1 .LE. 1048576) GO TO 60
 1005        IERR = 65
             CALL UTQS10(IERR,8)
  100  RETURN
      END
